: <<dis486pre.f>> ;

\ 11jun02sam local labelling @@n and @@n:
\ 01jun02sam the assembly code sort is now working
\ 29may02sam almost done, except some output format
\ 24may02sam begin porting dis486.f to F#

decimal

code 16BitSignExtend
  shl ebx , $10 
  sar ebx , $10 
  ret 
  end-code
  
code  8BitSignExtend
  shl ebx , $18 
  sar ebx , $18 
  ret 
  end-code

code cell-sort ( a n -- ) \ in place sorting of n-cell array
  push [ebp]         \ push array pointer a to return stack
  push ebx           \ push #cells n to return stack
  cmp  ebx , # 2     \ check if n>1
  jge  @@2           \ jump into loop, if true
  jmp  short @@3     \ otherwise, no need to sort
@@1:
  mov  eax , [ebx]   \ put current item a[0] at eax
  xchg eax , 4 [ebx] \ exchange eax with next item a[1]
  xchg eax , [ebx]   \ exchange eax with a[0] 
  cmp  eax , [ebx]   \ check if a[1]<a[0]
  jl   short @@1     \ loop back if true
  add  ebx , # 4     \ increment array pointer a
  loop @@1           \ loop back if n>0
@@2:
  pop  ecx           \ pop current n from return stack
  pop  ebx           \ pop current a from return stack
  push ebx           \ push current a to return stack
  dec  ecx           \ decrement n
  push ecx           \ push current n to return stack
  jg   short @@1     \ loop back if n>0
@@3:
  lea  esp , 8 [esp] \ pop current a and n from return stack
  mov  ebx , 4 [ebp] \ pop new top of data stack
  lea  ebp , 8 [ebp] \ reset data stack pointer
  ret                \ retuen to calling program
  end-code

code cincr ( addr -- ) 
  xor  eax , eax
  inc  eax
  add  [ebx] , al
  mov  ebx , [ebp]
  lea  ebp , 4 [ebp]
  ret
  end-code

CODE extract ( d -- d' n )
  mov     ecx , base
  xor     edx , edx
  mov     eax , ebx
  div     ecx
  mov     ebx , eax
  mov     eax , [ebp]
  div     ecx
  mov     [ebp] , eax
  lea     ebp , -4 [ebp]
  mov     [ebp] , ebx
  mov     ebx , edx
  ret
end-code

code upc ( lowerChar -- UpperChar )
  cmp  bl , # char a
  jb   short @@1
  cmp  bl , # char z
  ja   short @@1
  sub  bl , # $20
@@1:
  ret
  end-code

code dabs ( d -- d' )
  or ebx , ebx
  jge  short @@1
  call ' dnegate
@@1:
  ret
  end-code

$104 constant maxstring
$104 constant max-path
create spcs here maxstring allot maxstring bl fill 0 c,

: c+place ( c a -- ) dup cincr count + 1- c! ;
: ((")) ( -- a ) R> R> dup count + 1+ >R SWAP >R ; \ call by (.s")

$10 value maxLabel
create theLabel  here maxLabel cells allot  maxLabel cells erase
here value limitLabel  theLabel value entryLabel  0 value codeBase

: isLabel ( adr -- adr entry true | adr false )
  0 entryLabel theLabel
  ?do over i @ =
      if i nip true leave
      then cell
  +loop ;

: asLabel ( adr -- ) ?dup 0=
  if exit
  then entryLabel limitLabel >=
  if ." this disassembler can handle at most" limitLabel theLabel - cell/ .
     ."  local labels " abort
  then isLabel
  if ( adr entry ) 2drop exit
  then entryLabel ! cell +to entryLabel ;

0 value LabelSetting

: #s ( d -- d' ) begin # 2dup or 0= until ;
: (d.) ( d -- a n ) swap over dabs <# #s ROT SIGN #> ;
: s>d ( n -- d ) dup 0< ;
in-forth
: [char] bl word 1+ c@  [compile] literal ; \ 15jun02sam fixed for version 2.20
immediate compile-only

in-decompiler
: ?name ( ca -- ca | 0 ) dup
  NAME&VOC ( ca na va -1 | ca ca 0 ) >r 2drop r> 0=
  if 0
  then ;
' $" alias S"

: 0ParmAction create , 
  does> console.edit r> @ 0 0 
  ( handle MsgID null null ) SendMessageA ;
  CellsDoneList AppendLast

: 1ParmAction create , 
  does> console.edit r> @ rot 0 swap 
  ( handle MsgID null para ) SendMessageA ;
  CellsDoneList AppendLast

: 2ParmAction create , 
  does> console.edit r> @ 2swap 
  ( handle MsgID null para ) SendMessageA ;
  CellsDoneList AppendLast

  $00C ( WM_SETTEXT )       
	1ParmAction   	SetText       ( zString -- return )
  $00D ( WM_GETTEXT )       
	2ParmAction	GetText       ( buf size -- return )
  $00E ( WM_GETTEXTLENGTH ) 
	0ParmAction   	GetTextLength ( -- return )
  $0B1 ( EM_SETSEL )        
	2ParmAction   	SetSel        ( start end -- return )
  $0B0 ( EM_GETSEL )        
	0ParmAction   	GetSel        ( -- start ) ( @edx: -- end )
  $304 ( WM_UNDO )          
	0ParmAction   	Undo          ( -- return )
  $0C1 ( EM_LINELENGTH )    
	1ParmAction   	LineLength    ( line -- length )
  $031 ( WM_GETFONT )       
	0ParmAction   	GetFont       ( -- hFont )

: GetXY ( -- row col ) 0 sp@ 
  console.edit $B0 ( EM_SETSEL ) rot 0 sendmessagea drop ( CursorPos ) dup
  console.edit $C9 ( EM_LINEFROMCHAR ) rot 0 sendmessagea ( CursorPos row ) dup
  console.edit $BB ( EM_LINEINDEX ) rot 0 sendmessagea rot swap - ( row col )
  \ <<<<<<<<<<<<<<<<<<<< GetLineLength ?
;
: col ( col -- ) GetXY nip - ?dup
  IF dup 0<
     IF DROP SPACE
     ELSE SPACES
     THEN
  ELSE SPACE
  THEN ;
  
  CREATE TEXTMETRIC here $35 allot $35 erase
(  typedef struct tagTEXTMETRIC { // tm 
    LONG tmHeight; \ 0
    LONG tmAscent; \ 4
    LONG tmDescent; \ 8
    LONG tmInternalLeading; \ C
    LONG tmExternalLeading; \ 10
    LONG tmAveCharWidth; \ 14
    LONG tmMaxCharWidth; \ 18
    LONG tmWeight; \ 1C
    LONG tmOverhang; \ 20
    LONG tmDigitizedAspectX; \ 24
    LONG tmDigitizedAspectY; \ 28
    BCHAR tmFirstChar; \ 2C
    BCHAR tmLastChar; \ 2D
    BCHAR tmDefaultChar; \ 2E
    BCHAR tmBreakChar; \ 2F
    BYTE tmItalic; \ 30
    BYTE tmUnderlined; \ 31
    BYTE tmStruckOut; \ 32
    BYTE tmPitchAndFamily; \ 33
    BYTE tmCharSet; \ 34
  } TEXTMETRIC; 
)
2 gdi32 winapi: GetTextMetricsA
: RectWidth ( -- width )
  console.edit pad getwindowrect 0=
  abort" cannot getwindowrect" pad cell+ cell+ @ ;
: FontWidth ( -- width )
  console.edit dup GetDc dup TEXTMETRIC GetTextMetricsA 0=
  abort" cannot GetTextMetrics" ReleaseDc 0=
  abort" cannot ReleaseDc"
  TEXTMETRIC $18 + @ ;

: cols ( -- #col ) \ spcs SetText . 0 LineLength 
  RectWidth FontWidth / ;
  
: h.r ( n m -- ) base @ >r hex .r r> base ! ;
: u> swap u< ;
: 2H.N BASE @ >R HEX 0 <# # # #> TYPE R> BASE ! ;

create next-seq 1 c, $C3 c,

in-forth
' CompareString alias compare
in-decompiler

0 value tabing?
: tabing-on  true  to tabing? ;
: tabing-off false to tabing? ;
0 value TAB-MARGIN
: 0tab 0 to TAB-MARGIN ;
$4 VALUE RIGHT-MARGIN

: WRAP? cols RIGHT-MARGIN - > ;
: ?LINE 0 MAX GETXY DROP + WRAP?
  IF CR
  THEN ;
  
: START/STOP pause ?KEY ?dup
  IF dup $46 = over $66 = or
     IF $" wait> " query_loop
     THEN dup $1B =
     IF ABORT
     THEN
  THEN ;  

: \in-system-ok ;

  defer discode

      defer show-name   ( cfa -- )      \ display nearest symbol

0 value base-addr

create s-buf MAXSTRING allot

: >s            ( a1 n1 -- ) s-buf +place ;
: 0>s           ( -- ) s-buf off ;
: sspaces       ( n1 -- ) 0 max ?dup
  if spcs swap s-buf +place
  then ;
: emit>s        ( c1 -- ) s-buf c+place ;
: sspace        ( -- ) bl emit>s ;
: s>            ( -- a1 n1 ) s-buf count ;
: (.s")         ( -- ) ((")) count s-buf +place ;

' (.s") StringMoreList addToList \ adjust for F# 25may02sam

: .s"           ( 'text' -- ) compile (.s")  $,"  ; immediate
: d.r>s         ( d w -- ) >r (d.) r> over - sspaces >s ;
: .r>s          ( n w -- ) >r  s>d  r>  d.r>s ;
: h.>s          ( u -- ) base @ swap hex 0 .r>s base ! ;
: h.r>s         ( n1 n2 -- )
                base @ ( n1 n2 base ) >r >r ( n1 ) hex 
                0 <# #s #> ( a n ) r> over ( a n n2 n ) - sspaces >s
                r> base ! ;
: .id>s         ( nfa -- )
                nfa-count >s sspace ;

: .name>s       ( xt -- )
                dup >name dup \ name> ['] [unknown] =     \ if not found
                0= \ adjust for F# 25may02sam
                if drop [char] " emit>s .s" $" 1 h.r>s [char] " emit>s sspace
                else    .id>s drop
                then    ;

: nonAlpha ( c -- flag )
   dup [char] A < 
   over [char] Z 1+ [char] a 1- between or
   swap [char] z > or ;
   
: nonDigit ( c -- flag )
   dup [char] 0 <  swap [char] 9 > or ;
   
: masm.emit ( c -- ) ." _" h. ." _" ;
: masm.emit>s ( c -- ) [char] _ emit>s h.>s [char] _ emit>s ;
: masm.id ( na -- ) nfa-count
   over c@ dup nonAlpha 
   if masm.emit 
   else emit
   then
   1- swap 1+ swap bounds
   ?do i c@ dup nonAlpha over nonDigit and 
      if masm.emit 
      else emit
      then
   loop ;

: masm.id>s ( na -- )
  nfa-count ( entry a n ) 
  over c@ ( entry a n c ) dup nonAlpha
  if masm.emit>s 
  else emit>s
  then 1- swap 1+ swap bounds
  ?do i c@ dup nonAlpha over nonDigit and
     if masm.emit>s 
     else emit>s
     then
  loop ;
   
: >Label ( entry -- a n ) theLabel - cell/ 1+ 0 <# # ascii @ hold ascii @ hold #> ;

: .LabelEntry ( a -- a ) isLabel
  if ( a Entry ) masmFormat @
     if cr base-addr >name masm.id
     else swap a. swap 0mm.
     then >Label type ." : "
  then ;
: .LabelBind ( entry -- ) masmFormat @
  if base-addr >name masm.id>s
  else dup @ .s" ( " h.>s .s"  ) " 
  then >Label s-buf +place sspace ;

: n.>s ( ca -- ) LabelSetting 
  if drop exit
  then
  islabel
  if .LabelBind drop exit
  then
  dup UP DEFTIB $80 + within
  if .s" UP " UP - ?dup
     if h.>s .s"  + " 
     then exit
  then dup name&voc
  if ( ca na va ) rot .s" ( " h.>s .s"  ) | "
     ( na va ) cell- body> .name>s .s" ' " .id>s exit
  then ( ca ca ) body> name&voc
  if ( a na va ) 2 pick .s" ( " h.>s .s"  ) | " ( a na va ) 
     cell- body> .name>s swap ( na a ) @PreRel32BitAddr ['] doVAR =
     if .id>s exit
     then .s" ' " .id>s .s" >body " exit
  then ( a a ) drop CLINK 
  BEGIN @ ( a la ) ?DUP
  WHILE 2DUP CELL- @ =
     IF swap .s" ( " h.>s .s"  ) | " CELL- BODY> name&voc drop
        cell- body> .name>s .id>s exit
     THEN 
  REPEAT h.>s sspace ;

' n.>s is show-name

