Yap,

There are several problems with this code:
1.  When searching for ">>", there is no limit on how far it will search.  It will probably crash if there is no ">>" in the text.
2.  The IF ELSE0 THEN phrase after USEARCH1 is not balanced.  It works because there is always a ">" in the text.  If there is no ">", the data stack will have garbage, and the results will be unpredicatable.

You have to be prepared if the user forgets to terminate a tag, and give proper warnings.  Never allow FML to crash under any circumstance.

What do you think?

Ting.

PS.  I have to re-write USEARCH1 and UNICODE>.  I will send you the code later for you to review.



: doTag \ { a \ a+ tsize -- ... a' }
        DUP W@ [CHAR] < =
        IF  \ double tagstart and tagstop << >>
                DUP ( a -- )
                BEGIN DUP 2+ SWAP OVER W@ SWAP W@
                        [CHAR] > = SWAP [CHAR] > = AND
                        IF ( a a+ ) 2+ SWAP 2+ SWAP 2DUP SWAP - 4 - SWAP TRUE
                        ELSE FALSE THEN
                UNTIL
        ELSE \ single < >
                DUP ( a -- )
                $800 [CHAR] > USEARCH1 IF ELSE 0 THEN
                OVER + 2DUP SWAP - SWAP 2+
        THEN  ( a tsize a+ -- )
        >R
        ( a tsize )  UNICODE>
        2DUP >R >R
        ['] EVALUATE CATCH
        IF      CR ." Eval tag error: " . CR
                R> R> TYPE CR
        ELSE R> R> 2DROP THEN
        R>
        ;

